﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Windows.Media;
using System.IO;


namespace AimingGame
{
    public partial class Form1 : Form
    {
        int RocketLeft = 0;
        int Score = 0;
        bool Bull = false, GO = false, Hit = false;
        int[] PlainCenter = new int[2];
        int BigRocket = 0, Life = 5, Rocket = 15, HighScore = 0;
        bool b1000 = true, b2500 = true, b5000 = true, b7500 = true, b10000 = true, b12500 = true, b15000 = true, b17500 = true, b20000 = true;
        bool A = false, R = false, I = false, S = false, H = false;
        MediaPlayer objSound = new MediaPlayer();
        Uri BigRocketShoot = new Uri(Application.StartupPath + "//Media//BigRocketShoot.caf");
        Uri AimHit = new Uri(Application.StartupPath + "//Media//AimHit.caf");
        Uri PlaneHit = new Uri(Application.StartupPath + "//Media//PlaneHit.caf");


        public Form1()
        {
            InitializeComponent();
        }
        
        private void Form1_Load(object sender, EventArgs e)
        {
            ShowAim();
            txtPlane.Text = Life.ToString();
            txtRocket.Text = Rocket.ToString();
            txtRocketBig.Text = BigRocket.ToString();
            HighScoreLoad();
            lblHigh.Text = HighScore.ToString();
        }


        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (GO == true)
            {
                return;
            }
            switch (e.KeyCode)
            {
                case Keys.Down:
                    if (plane.Bottom >= Form1.ActiveForm.Height )
                    {
                        return;
                    }
                    plane.Top += 15;
                    break;
                case Keys.Up:
                    if (plane.Top <= 0)
                    {
                        return;
                    }
                    plane.Top -=15;
                    break;
                case Keys.Right:
                    if (plane.Right >= Form1.ActiveForm.Width)
                    {
                        return;
                    }
                    plane.Left += 15;
                    break;
                case Keys.Left:
                    if (plane.Left <= 0)
                    {
                        return;
                    }
                    plane.Left -= 15;
                    break;
                case Keys.Space:
                        if (Rocket == 0)
                        {
                            return;
                        }
                        RocketLeft = plane.Left;
                        rocketPic.Left = RocketLeft;
                        rocketPic.Top = plane.Top + plane.Height / 2;
                        rocketPic.Visible = true;
                        timer.Enabled = true;
                        RocketBig.Tag = "f";
                        rocketPic.Tag = "t";
                        Rocket -= 1;
                        txtRocket.Text = Rocket.ToString();
                        break;
                case Keys.Enter:
                        if (BigRocket == 0)
                        {
                            return;
                        }
                        RocketBig.Left = plane.Left;
                        RocketBig.Top = plane.Top + plane.Height / 2;
                        RocketBig.Visible = true;
                        timer.Enabled = true;
                        rocketPic.Tag = "f";
                        RocketBig.Tag = "t";
                        BigRocket -= 1;
                        txtRocketBig.Text = BigRocket.ToString();
                        objSound.Open(BigRocketShoot);
                        objSound.Play();
                        break;
                    
                case Keys.A:
                    if (e.Control==true)
                    {
                        A = true;
                    }
                    break;
                case Keys.R:
                    if (e.Control == true)
                    {
                        R = true;
                    }
                    break;
                case Keys.I:
                    if (e.Control == true)
                    {
                        I = true;
                    }
                    break;
                case Keys.S:
                    if (e.Control == true)
                    {
                        S = true;
                    }
                    break;
                case Keys.H:
                    if (e.Control == true)
                    {
                        H = true;
                    }
                    if (A == true && R == true && I == true && S == true && H == true)
                    {
                        Life = 1000;
                        Rocket = 1000;
                        BigRocket = 1000;
                        txtPlane.Text = Life.ToString();
                        txtRocket.Text = Rocket.ToString();
                        txtRocketBig.Text = BigRocket.ToString();
                    }
                    break;  
                case Keys.Escape:
                    if (e.Control == true && e.Alt==true)
                        Application.Exit();
                    break;
                case Keys.F1:
                    FrmHelp ObjHelp = new FrmHelp();
                    ObjHelp.ShowDialog();
                    break;
            }
            
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            if (rocketPic.Tag == "t")
            {
                RocketLeft  += 20;
                rocketPic.Left = RocketLeft;
                Shoot(rocketPic.Right, rocketPic.Top, "s");
            }
            else if (RocketBig.Tag == "t")
            {
                RocketBig.Left += 20;
                Shoot(RocketBig.Left, RocketBig.Top, "b");
            }
        }

        private void ShowAim()
        {
            Aim.Image = AimingGame.Properties.Resources.Tank;
            Aim2.Image = AimingGame.Properties.Resources.Machine;
            Aim3.Image = AimingGame.Properties.Resources.Machine;
            Aim4.Image = AimingGame.Properties.Resources.Jet;
            Aim5.Image = AimingGame.Properties.Resources.Jet;

            int[] Pos = new int[5];
            int[] HelpArray = new int[5];
            Random rndNo = new Random();
            for (int j = 0; j < 5; j++)
            {
                HelpArray[j] = 0;
            }
            int b = 0;
            int i = 0;
            while (i < 5)
            {
                b = rndNo.Next(0, 5);
                if (HelpArray[b] == 1)
                {
                    continue;
                }

                Pos[i] = b;
                HelpArray[b] = 1;
                i++;
            }

            Aim.Top = Pos[0] * 82 + 25;
            Aim2.Top = Pos[1] * 82 + 25;
            Aim3.Top = Pos[2] * 82 + 25;
            Aim4.Top = Pos[3] * 82 + 25;
            Aim5.Top = Pos[4] * 82 + 25;
            
            Aim.Left = 1100 ;
            Aim2.Left = 1100;
            Aim3.Left = 1100;
            Aim4.Left = 1100;
            Aim5.Left = 1100;

            Aim.Visible = true;
            Aim2.Visible = true;
            Aim3.Visible = true;
            Aim4.Visible = true;
            Aim5.Visible = true;

            AimTimer.Enabled = true;
            Aim2Timer.Enabled = true;
            Aim3Timer.Enabled = true;
            Aim4Timer.Enabled = true;
            Aim5Timer.Enabled = true;

            Aim.Tag="";
            Aim2.Tag="";
            Aim3.Tag="";
            Aim4.Tag="";
            Aim5.Tag = "";


            Bull = false;
            Hit = false;
        }

        private void MainTimer_Tick(object sender, EventArgs e)
        {
            ShowAim();
        }

        private void Shoot(int RocketRight,int RocketTop,string BigSmall)
        {
            objSound.Open(AimHit);
            if (BigSmall == "s")
            {


                if (RocketRight >= Aim.Left && RocketRight <= Aim.Right && RocketTop <= Aim.Bottom && RocketTop >= Aim.Top)
                {
                        if (Aim.Tag == "Hit")
                           return;
                        Aim.Tag = "Hit";
                        Score += 100;
                        txtScore.Text = Score.ToString();
                        Aim.Image = AimingGame.Properties.Resources.Boom;
                        AimTimer.Enabled = false;
                }
                else if (RocketRight >= Aim2.Left && RocketRight <= Aim2.Right && RocketTop <= Aim2.Bottom && RocketTop >= Aim2.Top)
                {
                    if (Aim2.Tag == "Hit")
                        return;
                    Aim2.Tag = "Hit";
                    Score += 200;
                    txtScore.Text = Score.ToString();
                    Aim2.Image = AimingGame.Properties.Resources.Boom;
                    Aim2Timer.Enabled = false;
                }
                else if (RocketRight >= Aim3.Left && RocketRight <= Aim3.Right && RocketTop <= Aim3.Bottom && RocketTop >= Aim3.Top)
                {
                    if (Aim3.Tag == "Hit")
                        return;
                    Aim3.Tag = "Hit";
                    Score += 300;
                    txtScore.Text = Score.ToString();
                    Aim3.Image = AimingGame.Properties.Resources.Boom;
                    Aim3Timer.Enabled = false;
                }
                else if (RocketRight >= Aim4.Left && RocketRight <= Aim4.Right && RocketTop <= Aim4.Bottom && RocketTop >= Aim4.Top)
                {
                    if (Aim4.Tag == "Hit")
                        return;
                    Aim4.Tag = "Hit";
                    Score += 400;
                    txtScore.Text = Score.ToString();
                    Aim4.Image = AimingGame.Properties.Resources.Boom;
                    Aim4Timer.Enabled = false;
                }
                else if (RocketRight >= Aim5.Left && RocketRight <= Aim5.Right && RocketTop <= Aim5.Bottom && RocketTop >= Aim5.Top)
                {
                    if (Aim5.Tag == "Hit")
                        return;
                    Aim5.Tag = "Hit";
                    Score += 500;
                    txtScore.Text = Score.ToString();
                    Aim5.Image = AimingGame.Properties.Resources.Boom;
                    Aim5Timer.Enabled = false;
                }
            }
            else if (BigSmall == "b")
            {
                if ((RocketRight >= Aim.Left && RocketRight <= Aim.Right && RocketTop <= Aim.Bottom && RocketTop >= Aim.Top) ||
                    (RocketRight >= Aim2.Left && RocketRight <= Aim2.Right && RocketTop <= Aim2.Bottom && RocketTop >= Aim2.Top) ||
                    (RocketRight >= Aim3.Left && RocketRight <= Aim3.Right && RocketTop <= Aim3.Bottom && RocketTop >= Aim3.Top) ||
                    (RocketRight >= Aim4.Left && RocketRight <= Aim4.Right && RocketTop <= Aim4.Bottom && RocketTop >= Aim4.Top) ||
                    (RocketRight >= Aim5.Left && RocketRight <= Aim5.Right && RocketTop <= Aim5.Bottom && RocketTop >= Aim5.Top))
                {
                    Score += 750;
                    txtScore.Text = Score.ToString();
                    Aim.Image = AimingGame.Properties.Resources.Boom;
                    Aim.Tag = "Hit";
                    AimTimer.Enabled = false;
                    Aim2.Image = AimingGame.Properties.Resources.Boom;
                    Aim2.Tag = "Hit";
                    Aim2Timer.Enabled = false;
                    Aim3.Image = AimingGame.Properties.Resources.Boom;
                    Aim3.Tag = "Hit";
                    Aim3Timer.Enabled = false;
                    Aim4.Image = AimingGame.Properties.Resources.Boom;
                    Aim4.Tag = "Hit";
                    Aim4Timer.Enabled = false;
                    Aim5.Image = AimingGame.Properties.Resources.Boom;
                    Aim5.Tag = "Hit";
                    Aim5Timer.Enabled = false;
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void AimTimer_Tick(object sender, EventArgs e)
        {
            Aim.Left -= 10;

            PlainCenter[0] = plane.Location.X + 30;
            PlainCenter[1] = plane.Location.Y;
            if (Hit == true)
            {
                return;
            }
            if (PlainCenter[0] > Aim.Left && PlainCenter[0] < Aim.Right
                && ((PlainCenter[1] < Aim.Bottom && PlainCenter[1] > Aim.Top) ||
                (PlainCenter[1] + plane.Height < Aim.Bottom && PlainCenter[1] + plane.Height > Aim.Top)))
            {
                LifeCheck();
                Hit = true;
            }
        }

        private void Aim2Timer_Tick(object sender, EventArgs e)
        {
            Aim2.Left -= 12;
            PlainCenter[0] = plane.Location.X + 30;
            PlainCenter[1] = plane.Location.Y;
            if (Hit == true)
            {
                return;
            }
            if (PlainCenter[0] > Aim2.Left && PlainCenter[0] < Aim2.Right
                && ((PlainCenter[1] < Aim2.Bottom && PlainCenter[1] > Aim2.Top) ||
                (PlainCenter[1] + plane.Height < Aim2.Bottom && PlainCenter[1] + plane.Height > Aim2.Top)))
            {
                LifeCheck();
                Hit = true;
            }
        }

        private void Aim3Timer_Tick(object sender, EventArgs e)
        {
            Aim3.Left -= 14;
            PlainCenter[0] = plane.Location.X + 30;
            PlainCenter[1] = plane.Location.Y;
            if (Hit == true)
            {
                return;
            }
            if (PlainCenter[0] > Aim3.Left && PlainCenter[0] < Aim3.Right
                && ((PlainCenter[1] < Aim3.Bottom && PlainCenter[1] > Aim3.Top) ||
                (PlainCenter[1] + plane.Height < Aim3.Bottom && PlainCenter[1] + plane.Height > Aim3.Top)))
            {
                LifeCheck();
                Hit = true;
            }
        }

        private void Aim4Timer_Tick(object sender, EventArgs e)
        {

            Aim4.Left -= 16;
            PlainCenter[0] = plane.Location.X + 30;
            PlainCenter[1] = plane.Location.Y;
            if (Hit == true)
            {
                return;
            }
            if (PlainCenter[0] > Aim4.Left && PlainCenter[0] < Aim4.Right
                && ((PlainCenter[1] < Aim4.Bottom && PlainCenter[1] > Aim4.Top) ||
                (PlainCenter[1] + plane.Height < Aim4.Bottom && PlainCenter[1] + plane.Height > Aim4.Top)))
            {
                LifeCheck();
                Hit = true;
            }
        }

        private void Aim5Timer_Tick(object sender, EventArgs e)
        {

            Aim5.Left -= 18;
            PlainCenter[0] = plane.Location.X + 30;
            PlainCenter[1] = plane.Location.Y;
            if (Hit == true)
            {
                return;
            }
            if (PlainCenter[0] > Aim5.Left && PlainCenter[0] < Aim5.Right
                && ((PlainCenter[1] < Aim5.Bottom && PlainCenter[1] > Aim5.Top) ||
                (PlainCenter[1] + plane.Height < Aim5.Bottom && PlainCenter[1] + plane.Height > Aim5.Top)))
            {
                LifeCheck();
                Hit = true;
            }
        }

        private void LifeCheck()
        {
            objSound.Open(PlaneHit);
            objSound.Play();
            if (Life == 0)
            {
                timer.Enabled = false;
                MainTimer.Enabled = false;
                AimTimer.Enabled = false;
                Aim2Timer.Enabled = false;
                Aim3Timer.Enabled = false;
                Aim4Timer.Enabled = false;
                Aim5Timer.Enabled = false;

                plane.Image = AimingGame.Properties.Resources.BoomPlane;
                txtScore.Text = "Game Over!";
                HighScoreCheck();
                this.BackColor = System.Drawing.Color.Firebrick;
                GO = true;
                button2.Visible = true;
                this.AcceptButton = button2;
                plane.BackColor = System.Drawing.Color.Maroon;
                this.Location = new Point(this.Location.X + 2, this.Location.Y - 2);
                System.Timers.Timer Time = new System.Timers.Timer();
                Time.Interval = 500;
                Time.Start();
                if (Time.Enabled == false)
                {
                    plane.BackColor = System.Drawing.Color.Transparent;
                    this.Location = new Point(90,141);
                }
            }
            else
            {
                Life -= 1;
                txtPlane.Text = Life.ToString();
            }

            System.Drawing.Color a = this.BackColor;
            this.BackColor = System.Drawing.Color.Maroon;
            this.Location = new Point(this.Location.X + 2, this.Location.Y - 2);
            for (int i = 0; i < 100000000; i++)
            {
                
            }
            this.BackColor = a;
            this.Location = new Point(this.Location.X - 2, this.Location.Y + 2);
            
            
        }

        private void txtScore_TextChanged(object sender, EventArgs e)
        {
            if (Score >= 1000 && b1000==true)
            {
                Rocket += 2;
                b1000 = false;
                txtRocket.Text = Rocket.ToString();
            }
            if (Score >= 2500 && b2500 == true)
            {
                Rocket += 2;
                b2500 = false;
                txtRocket.Text = Rocket.ToString();
                txtPlane.Text = Life.ToString();
            }
            if (Score >= 5000 && b5000 == true)
            {
                Rocket += 2;
                Life += 1;
                BigRocket += 1;
                b5000 = false;
                txtRocket.Text = Rocket.ToString();
                txtPlane.Text = Life.ToString();
                txtRocketBig.Text = BigRocket.ToString();
            }
            if (Score >= 7500 && b7500 == true)
            {
                Rocket += 2;
                BigRocket += 1;
                b7500 = false;
                txtRocket.Text = Rocket.ToString();
                txtPlane.Text = Life.ToString();
                txtRocketBig.Text = BigRocket.ToString();
            }
            if (Score >= 10000 && b10000 == true)
            {
                Rocket += 3;
                Life += 1;
                BigRocket += 1;
                b10000 = false;
                txtRocket.Text = Rocket.ToString();
                txtPlane.Text = Life.ToString();
                txtRocketBig.Text = BigRocket.ToString();
            }
            
            if (Score >= 15000 && b15000 == true)
            {
                Rocket += 3;
                BigRocket += 1;
                b15000 = false;
                txtRocket.Text = Rocket.ToString();
                txtPlane.Text = Life.ToString();
                txtRocketBig.Text = BigRocket.ToString();
            }
            if (Score >= 20000 && b20000 == true)
            {
                Rocket += 200;
                Life += 100;
                BigRocket += 100;
                b20000 = false;
                txtRocket.Text = Rocket.ToString();
                txtPlane.Text = Life.ToString();
                txtRocketBig.Text = BigRocket.ToString();
            }

        }

        private void Save()
        {
            FileStream ObjStream = new FileStream(Application.StartupPath + "//Media//AAGSF.sav", FileMode.Create);
            BinaryWriter objSave = new BinaryWriter(ObjStream);
            string StrSave, FBig, FScore, FRocket, FLife;
            FBig = String.Format("{0:00000}", BigRocket);
            FRocket = String.Format("{0:00000}", Rocket);
            FLife = String.Format("{0:00000}", Life);
            FScore = String.Format("{0:00000}", Score);
            StrSave = FLife + FRocket + FBig + FScore;
            objSave.Write(StrSave);
            objSave.Close();
            ObjStream.Close();
            lblCon.Text = "Game Saved!!!";
            lblCon.Visible = true;
            lblCon.Refresh();
            for (int i = 0; i < 100000000; i++)
            {
            }
            lblCon.Visible = false;
        }
        private void load()
        {
            FileStream ObjStream = new FileStream(Application.StartupPath + "//Media//AAGSF.sav", FileMode.OpenOrCreate);
            BinaryReader objLoad = new BinaryReader(ObjStream);
            string StrLoad = objLoad.ReadString();
            int a = 0;
            for (int i = 4; i < 20; i = i + 5)
            {
                a = Convert.ToInt32(StrLoad[i].ToString()) + 10 * Convert.ToInt32(StrLoad[i - 1].ToString())
                                    + 100 * Convert.ToInt32(StrLoad[i - 2].ToString()) + 1000 * Convert.ToInt32(StrLoad[i - 3].ToString())
                                    + 10000 * Convert.ToInt32(StrLoad[i - 4].ToString());
                switch (i)
                {
                    case 4:
                        Life = a;
                        break;
                    case 9:
                        Rocket = a;
                        break;
                    case 14:
                        BigRocket = a;
                        break;
                    case 19:
                        Score = a;
                        break;
                }

            }
            objLoad.Close();
            ObjStream.Close();
            txtPlane.Text = Life.ToString();
            txtRocket.Text = Rocket.ToString();
            txtScore.Text = BigRocket.ToString();
            txtScore.Text = Score.ToString();
            lblCon.Text = "Game Loaded!!!";
            lblCon.Visible = true;
            lblCon.Refresh();
            for (int i = 0; i < 100000000; i++)
            {
            }
            lblCon.Visible = false;
        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Save();
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            load();
        }
        private void HighScoreLoad()
        {
            FileStream HighLoad = new FileStream(Application.StartupPath + "//Media//AAGHS.ash", FileMode.OpenOrCreate);
            BinaryReader objLoadHigh = new BinaryReader(HighLoad);
            try
            {
                HighScore = objLoadHigh.ReadInt32();
            }
            catch
            {
                HighScore = 0;
            }
        }
        private void HighScoreCheck()
        {
            if (Score > HighScore)
            {
                FileStream HighStream = new FileStream(Application.StartupPath + "//Media//AAGHS.ash", FileMode.Create);
                BinaryWriter objWriteHigh = new BinaryWriter(HighStream);
                objWriteHigh.Write(Score);
                lblCon.Visible = true;
                lblCon.Text = "New HighScore!!!";
            }
        }
    }
}
